%bcond_without check

# Disable debug package
%global debug_package %{nil}

%ifarch aarch64
%global defaultArch     arm64
%endif

%ifarch x86_64
%global defaultArch     amd64
%endif

# https://github.com/openshift/installer
%global goipath         github.com/openshift/installer
%global commit          b7e59a8164ae8ca70f5f13cd75a948b5ddc67378

%gometa

%global golicenses      LICENSE NOTICE
%global godocs          docs CHANGELOG.md CONTRIBUTING.md README.md code-of-\\\
                        conduct.md data/data/baremetal/bootstrap/README.md\\\
                        data/data/bootstrap/baremetal/README.md\\\
                        data/data/bootstrap/nutanix/README.md\\\
                        data/data/bootstrap/ovirt/README.md\\\
                        data/data/libvirt/bootstrap/README.md\\\
                        images/libvirt/README.md\\\
                        pkg/terraform/providers/mirror/README\\\
                        upi/openstack/README.md upi/ovirt/README.md\\\
                        upi/vsphere/README.md upi/metal/README.md

%global major 4
%global minor 10
%global patch 0

Name:           openshift-installer
Version:        %{major}.%{minor}.%{patch}
Release:        1%{?dist}
Summary:        Install an OpenShift 4.x cluster

License:        Apache-2.0
URL:            %{gourl}
Source0:        https://%{goipath}/archive/%{commit}/installer-%{commit}.tar.gz

Source1:        vendor2provides.py

BuildRequires:  git-core
BuildRequires:  golang-bin >= 1.17
BuildRequires:  gcc-c++
BuildRequires:  libvirt-devel

Provides:       openshift-installer = %{version}-%{release}

Requires:       bash-completion

# vendored libraries
# fedpkg prep
# ./vendor2provides.py installer-%%{commit}/vendor/modules.txt
Provides:       bundled(golang(cloud.google.com/go)) = 0.57.0
Provides:       bundled(golang(cloud.google.com/go/bigtable)) = 1.5.0
Provides:       bundled(golang(cloud.google.com/go/storage)) = 1.11.0
Provides:       bundled(golang(github.com/AlecAivazis/survey/v2)) = 2.2.12
Provides:       bundled(golang(github.com/Azure/azure-sdk-for-go)) = 51.2.0+incompatible
Provides:       bundled(golang(github.com/Azure/go-autorest)) = 14.2.0+incompatible
Provides:       bundled(golang(github.com/Azure/go-autorest/autorest)) = 0.11.17
Provides:       bundled(golang(github.com/Azure/go-autorest/autorest/adal)) = 0.9.10
Provides:       bundled(golang(github.com/Azure/go-autorest/autorest/azure/auth)) = 0.4.1
Provides:       bundled(golang(github.com/Azure/go-autorest/autorest/azure/cli)) = 0.4.2
Provides:       bundled(golang(github.com/Azure/go-autorest/autorest/date)) = 0.3.0
Provides:       bundled(golang(github.com/Azure/go-autorest/autorest/to)) = 0.4.0
Provides:       bundled(golang(github.com/Azure/go-autorest/autorest/validation)) = 0.3.1
Provides:       bundled(golang(github.com/Azure/go-autorest/logger)) = 0.2.1
Provides:       bundled(golang(github.com/Azure/go-autorest/tracing)) = 0.6.0
Provides:       bundled(golang(github.com/Azure/go-ntlmssp)) = 6637195
Provides:       bundled(golang(github.com/BurntSushi/toml)) = 0.3.1
Provides:       bundled(golang(github.com/ChrisTrenkamp/goxpath)) = c5096ec
Provides:       bundled(golang(github.com/IBM-Cloud/bluemix-go)) = cdc80c9
Provides:       bundled(golang(github.com/IBM-Cloud/power-go-client)) = 1.0.55
Provides:       bundled(golang(github.com/openshift/terraform-provider-ibm)) = 1.26.2
Provides:       bundled(golang(github.com/IBM/apigateway-go-sdk)) = a5d5d49
Provides:       bundled(golang(github.com/IBM/appconfiguration-go-admin-sdk)) = 0.1.0
Provides:       bundled(golang(github.com/IBM/container-registry-go-sdk)) = 0.0.13
Provides:       bundled(golang(github.com/IBM/go-sdk-core)) = 1.1.0
Provides:       bundled(golang(github.com/IBM/go-sdk-core/v3)) = 3.3.1
Provides:       bundled(golang(github.com/IBM/go-sdk-core/v4)) = 4.10.0
Provides:       bundled(golang(github.com/IBM/go-sdk-core/v5)) = 5.4.3
Provides:       bundled(golang(github.com/IBM/ibm-cos-sdk-go)) = 1.7.0
Provides:       bundled(golang(github.com/IBM/ibm-cos-sdk-go-config)) = 1.2.0
Provides:       bundled(golang(github.com/IBM/keyprotect-go-client)) = 0.7.0
Provides:       bundled(golang(github.com/IBM/networking-go-sdk)) = 0.14.0
Provides:       bundled(golang(github.com/IBM/platform-services-go-sdk)) = 0.18.16
Provides:       bundled(golang(github.com/IBM/push-notifications-go-sdk)) = 5790b96
Provides:       bundled(golang(github.com/IBM/schematics-go-sdk)) = 0.0.2
Provides:       bundled(golang(github.com/IBM/secrets-manager-go-sdk)) = 0.1.19
Provides:       bundled(golang(github.com/IBM/vpc-go-sdk)) = 0.7.0
Provides:       bundled(golang(github.com/Masterminds/goutils)) = 1.1.0
Provides:       bundled(golang(github.com/Masterminds/semver)) = 1.5.0
Provides:       bundled(golang(github.com/Masterminds/sprig)) = 2.22.0+incompatible
Provides:       bundled(golang(github.com/Netflix/go-expect)) = 0e00d91
Provides:       bundled(golang(github.com/PaesslerAG/gval)) = 1.0.0
Provides:       bundled(golang(github.com/PaesslerAG/jsonpath)) = 0.1.1
Provides:       bundled(golang(github.com/PuerkitoBio/purell)) = 1.1.1
Provides:       bundled(golang(github.com/PuerkitoBio/urlesc)) = de5bf2a
Provides:       bundled(golang(github.com/ScaleFT/sshkeys)) = 6142f74
Provides:       bundled(golang(github.com/Shopify/sarama)) = 1.27.2
Provides:       bundled(golang(github.com/agext/levenshtein)) = 1.2.3
Provides:       bundled(golang(github.com/alibabacloud-go/cs-20151215/v2)) = 2.4.4
Provides:       bundled(golang(github.com/alibabacloud-go/darabonba-openapi)) = 0.1.5
Provides:       bundled(golang(github.com/alibabacloud-go/debug)) = 9472017
Provides:       bundled(golang(github.com/alibabacloud-go/endpoint-util)) = 1.1.0
Provides:       bundled(golang(github.com/alibabacloud-go/openapi-util)) = 0.0.7
Provides:       bundled(golang(github.com/alibabacloud-go/tea)) = 1.1.17
Provides:       bundled(golang(github.com/alibabacloud-go/tea-roa)) = 1.3.0
Provides:       bundled(golang(github.com/alibabacloud-go/tea-roa-utils)) = 1.1.5
Provides:       bundled(golang(github.com/alibabacloud-go/tea-rpc)) = 1.2.0
Provides:       bundled(golang(github.com/alibabacloud-go/tea-rpc-utils)) = 1.1.2
Provides:       bundled(golang(github.com/alibabacloud-go/tea-utils)) = 1.3.9
Provides:       bundled(golang(github.com/aliyun/alibaba-cloud-sdk-go)) = 1.61.1264
Provides:       bundled(golang(github.com/aliyun/aliyun-datahub-sdk-go)) = 0.1.5
Provides:       bundled(golang(github.com/aliyun/aliyun-log-go-sdk)) = 0.1.27
Provides:       bundled(golang(github.com/aliyun/aliyun-mns-go-sdk)) = d1b5875
Provides:       bundled(golang(github.com/aliyun/aliyun-oss-go-sdk)) = 2.1.8+incompatible
Provides:       bundled(golang(github.com/aliyun/aliyun-tablestore-go-sdk)) = 4.1.3+incompatible
Provides:       bundled(golang(github.com/aliyun/credentials-go)) = 1.1.2
Provides:       bundled(golang(github.com/aliyun/fc-go-sdk)) = c013428
Provides:       bundled(golang(github.com/aliyun/terraform-provider-alicloud)) = 1.153.0
Provides:       bundled(golang(github.com/andybalholm/brotli)) = 1.0.1
Provides:       bundled(golang(github.com/antchfx/xpath)) = 1.1.2
Provides:       bundled(golang(github.com/apache/openwhisk-client-go)) = a804fb8
Provides:       bundled(golang(github.com/apparentlymart/go-cidr)) = 1.1.0
Provides:       bundled(golang(github.com/apparentlymart/go-textseg/v12)) = 12.0.0
Provides:       bundled(golang(github.com/apparentlymart/go-textseg/v13)) = 13.0.0
Provides:       bundled(golang(github.com/apparentlymart/go-versions)) = 1.0.1
Provides:       bundled(golang(github.com/armon/circbuf)) = 5111143
Provides:       bundled(golang(github.com/armon/go-radix)) = 1.0.0
Provides:       bundled(golang(github.com/asaskevich/govalidator)) = f21760c
Provides:       bundled(golang(github.com/awalterschulze/gographviz)) = fa59802
Provides:       bundled(golang(github.com/aws/aws-sdk-go)) = 1.35.37
Provides:       bundled(golang(github.com/beevik/etree)) = 1.1.0
Provides:       bundled(golang(github.com/beorn7/perks)) = 1.0.1
Provides:       bundled(golang(github.com/bgentry/go-netrc)) = 9fd32a8
Provides:       bundled(golang(github.com/bgentry/speakeasy)) = 0.1.0
Provides:       bundled(golang(github.com/bmatcuk/doublestar)) = 1.3.2
Provides:       bundled(golang(github.com/btubbs/datetime)) = 0.1.0
Provides:       bundled(golang(github.com/c4milo/gotoolkit)) = e37eeab
Provides:       bundled(golang(github.com/cenkalti/backoff)) = 2.2.1+incompatible
Provides:       bundled(golang(github.com/cespare/xxhash/v2)) = 2.1.1
Provides:       bundled(golang(github.com/chzyer/readline)) = 2972be2
Provides:       bundled(golang(github.com/clarketm/json)) = 1.14.1
Provides:       bundled(golang(github.com/cloudfoundry/jibber_jabber)) = bcc4c83
Provides:       bundled(golang(github.com/containers/image)) = 3.0.2+incompatible
Provides:       bundled(golang(github.com/coreos/go-json)) = 5ae6071
Provides:       bundled(golang(github.com/coreos/go-semver)) = 0.3.0
Provides:       bundled(golang(github.com/coreos/go-systemd/v22)) = 22.3.2
Provides:       bundled(golang(github.com/coreos/ignition/v2)) = 2.9.0
Provides:       bundled(golang(github.com/coreos/stream-metadata-go)) = 0.1.3
Provides:       bundled(golang(github.com/coreos/vcontext)) = b0e13da
Provides:       bundled(golang(github.com/davecgh/go-spew)) = 1.1.1
Provides:       bundled(golang(github.com/dchest/bcrypt_pbkdf)) = 83f37f9
Provides:       bundled(golang(github.com/deckarep/golang-set)) = 1.8.0
Provides:       bundled(golang(github.com/denverdino/aliyungo)) = 6cc9484
Provides:       bundled(golang(github.com/dgrijalva/jwt-go)) = 3.2.0+incompatible
Provides:       bundled(golang(github.com/dimchansky/utfbom)) = 1.1.1
Provides:       bundled(golang(github.com/dmacvicar/terraform-provider-libvirt)) = 2b60d76
Provides:       bundled(golang(github.com/dustinkirkland/golang-petname)) = 8e5a1ed
Provides:       bundled(golang(github.com/dylanmei/iso8601)) = 0.1.0
Provides:       bundled(golang(github.com/eapache/go-resiliency)) = 1.2.0
Provides:       bundled(golang(github.com/eapache/go-xerial-snappy)) = 776d571
Provides:       bundled(golang(github.com/eapache/queue)) = 1.1.0
Provides:       bundled(golang(github.com/evanphx/json-patch)) = 4.12.0+incompatible
Provides:       bundled(golang(github.com/fatih/color)) = 1.12.0
Provides:       bundled(golang(github.com/form3tech-oss/jwt-go)) = 3.2.3+incompatible
Provides:       bundled(golang(github.com/fsnotify/fsnotify)) = 1.5.1
Provides:       bundled(golang(github.com/gammazero/deque)) = 2afb385
Provides:       bundled(golang(github.com/gammazero/workerpool)) = 88d534f
Provides:       bundled(golang(github.com/ghodss/yaml)) = 25d852a
Provides:       bundled(golang(github.com/go-kit/kit)) = 0.10.0
Provides:       bundled(golang(github.com/go-logfmt/logfmt)) = 0.5.0
Provides:       bundled(golang(github.com/go-logr/logr)) = 1.2.0
Provides:       bundled(golang(github.com/go-openapi/analysis)) = 0.19.5
Provides:       bundled(golang(github.com/go-openapi/errors)) = 0.19.2
Provides:       bundled(golang(github.com/go-openapi/jsonpointer)) = 0.19.5
Provides:       bundled(golang(github.com/go-openapi/jsonreference)) = 0.19.5
Provides:       bundled(golang(github.com/go-openapi/loads)) = 0.19.4
Provides:       bundled(golang(github.com/go-openapi/runtime)) = 0.19.11
Provides:       bundled(golang(github.com/go-openapi/spec)) = 0.19.4
Provides:       bundled(golang(github.com/go-openapi/strfmt)) = 0.20.1
Provides:       bundled(golang(github.com/go-openapi/swag)) = 0.19.14
Provides:       bundled(golang(github.com/go-openapi/validate)) = 0.19.8
Provides:       bundled(golang(github.com/go-playground/locales)) = 0.13.0
Provides:       bundled(golang(github.com/go-playground/universal-translator)) = 0.17.0
Provides:       bundled(golang(github.com/go-playground/validator/v10)) = 10.2.0
Provides:       bundled(golang(github.com/go-stack/stack)) = 1.8.0
Provides:       bundled(golang(github.com/gobuffalo/flect)) = 0.2.3
Provides:       bundled(golang(github.com/gofrs/uuid)) = 3.3.0+incompatible
Provides:       bundled(golang(github.com/gogap/errors)) = 149c546
Provides:       bundled(golang(github.com/gogap/stack)) = fef68dd
Provides:       bundled(golang(github.com/gogo/protobuf)) = 1.3.2
Provides:       bundled(golang(github.com/golang/groupcache)) = 41bb18b
Provides:       bundled(golang(github.com/golang/mock)) = 1.6.0
Provides:       bundled(golang(github.com/golang/protobuf)) = 1.5.2
Provides:       bundled(golang(github.com/golang/snappy)) = 0.0.1
Provides:       bundled(golang(github.com/google/go-cmp)) = 0.5.6
Provides:       bundled(golang(github.com/google/go-querystring)) = 1.1.0
Provides:       bundled(golang(github.com/google/gofuzz)) = 1.2.0
Provides:       bundled(golang(github.com/google/martian)) = incompa
Provides:       bundled(golang(github.com/google/renameio)) = 1.0.0
Provides:       bundled(golang(github.com/google/uuid)) = 1.2.0
Provides:       bundled(golang(github.com/googleapis/gax-go/v2)) = 2.0.5
Provides:       bundled(golang(github.com/googleapis/gnostic)) = 0.5.5
Provides:       bundled(golang(github.com/gophercloud/gophercloud)) = 0.17.0
Provides:       bundled(golang(github.com/gophercloud/utils)) = 8a3ad2a
Provides:       bundled(golang(github.com/h2non/filetype)) = 1.0.12
Provides:       bundled(golang(github.com/hashicorp/aws-sdk-go-base)) = 0.7.0
Provides:       bundled(golang(github.com/hashicorp/errwrap)) = 1.0.0
Provides:       bundled(golang(github.com/hashicorp/go-azure-helpers)) = 0.16.5
Provides:       bundled(golang(github.com/hashicorp/go-checkpoint)) = 0.5.0
Provides:       bundled(golang(github.com/hashicorp/go-cleanhttp)) = 0.5.2
Provides:       bundled(golang(github.com/hashicorp/go-getter)) = 1.5.2
Provides:       bundled(golang(github.com/hashicorp/go-hclog)) = 0.14.1
Provides:       bundled(golang(github.com/hashicorp/go-multierror)) = 1.1.0
Provides:       bundled(golang(github.com/hashicorp/go-plugin)) = 1.3.0
Provides:       bundled(golang(github.com/hashicorp/go-retryablehttp)) = 0.6.6
Provides:       bundled(golang(github.com/hashicorp/go-safetemp)) = 1.0.0
Provides:       bundled(golang(github.com/hashicorp/go-slug)) = 0.4.1
Provides:       bundled(golang(github.com/hashicorp/go-tfe)) = 0.8.1
Provides:       bundled(golang(github.com/hashicorp/go-uuid)) = 1.0.2
Provides:       bundled(golang(github.com/hashicorp/go-version)) = 1.3.0
Provides:       bundled(golang(github.com/hashicorp/hcl)) = 1.0.0
Provides:       bundled(golang(github.com/hashicorp/hcl/v2)) = 2.8.2
Provides:       bundled(golang(github.com/hashicorp/logutils)) = 1.0.0
Provides:       bundled(golang(github.com/openshift/hashicorp-terraform)) = 0.14.6
Provides:       bundled(golang(github.com/hashicorp/terraform-config-inspect)) = c481b8b
Provides:       bundled(golang(github.com/hashicorp/terraform-exec)) = 0.13.1
Provides:       bundled(golang(github.com/hashicorp/terraform-json)) = 0.9.0
Provides:       bundled(golang(github.com/openshift/hashicorp-terraform-plugin-sdk)) = 1.16.0
Provides:       bundled(golang(github.com/hashicorp/terraform-plugin-test/v2)) = 2.2.0
Provides:       bundled(golang(github.com/hashicorp/terraform-provider-google)) = 78da461
Provides:       bundled(golang(github.com/openshift/terraform-provider-vsphere)) = 1.24.3
Provides:       bundled(golang(github.com/hashicorp/terraform-svchost)) = f050f53
Provides:       bundled(golang(github.com/hashicorp/vault)) = 1.3.0
Provides:       bundled(golang(github.com/hashicorp/yamux)) = aecfd21
Provides:       bundled(golang(github.com/hinshun/vt10x)) = d55458d
Provides:       bundled(golang(github.com/hokaccha/go-prettyjson)) = e6b9231
Provides:       bundled(golang(github.com/hooklift/iso9660)) = 1.0.0
Provides:       bundled(golang(github.com/huandu/xstrings)) = 1.3.2
Provides:       bundled(golang(github.com/imdario/mergo)) = 0.3.12
Provides:       bundled(golang(github.com/inconshreveable/mousetrap)) = 1.0.0
Provides:       bundled(golang(github.com/jcmturner/gofork)) = 1.0.0
Provides:       bundled(golang(github.com/jen20/awspolicyequivalence)) = 1.1.0
Provides:       bundled(golang(github.com/jmespath/go-jmespath)) = 0.4.0
Provides:       bundled(golang(github.com/josharian/intern)) = 1.0.0
Provides:       bundled(golang(github.com/json-iterator/go)) = 1.1.12
Provides:       bundled(golang(github.com/jstemmer/go-junit-report)) = 0.9.1
Provides:       bundled(golang(github.com/kardianos/osext)) = 2bc1f35
Provides:       bundled(golang(github.com/kballard/go-shellquote)) = 95032a8
Provides:       bundled(golang(github.com/keybase/go-crypto)) = de78d2c
Provides:       bundled(golang(github.com/klauspost/compress)) = 1.11.8
Provides:       bundled(golang(github.com/kr/fs)) = 0.1.0
Provides:       bundled(golang(github.com/kr/pretty)) = 0.2.1
Provides:       bundled(golang(github.com/kr/text)) = 0.2.0
Provides:       bundled(golang(github.com/leodido/go-urn)) = 1.2.1
Provides:       bundled(golang(github.com/libvirt/libvirt-go)) = 5.10.0+incompatible
Provides:       bundled(golang(github.com/libvirt/libvirt-go-xml)) = 5.10.0+incompatible
Provides:       bundled(golang(github.com/mailru/easyjson)) = 0.7.6
Provides:       bundled(golang(github.com/masterzen/simplexml)) = 31eea30
Provides:       bundled(golang(github.com/masterzen/winrm)) = c42b513
Provides:       bundled(golang(github.com/mattn/go-colorable)) = 0.1.8
Provides:       bundled(golang(github.com/mattn/go-isatty)) = 0.0.12
Provides:       bundled(golang(github.com/matttproud/golang_protobuf_extensions)) = c182aff
Provides:       bundled(golang(github.com/openshift/baremetal-operator)) = 28771f4
Provides:       bundled(golang(github.com/openshift/baremetal-operator/apis)) = 28771f4
Provides:       bundled(golang(github.com/openshift/baremetal-operator/pkg/hardwareutils)) = 28771f4
Provides:       bundled(golang(github.com/mgutz/ansi)) = 9520e82
Provides:       bundled(golang(github.com/minsikl/netscaler-nitro-go)) = 5b14ce3
Provides:       bundled(golang(github.com/mitchellh/cli)) = 1.1.2
Provides:       bundled(golang(github.com/mitchellh/colorstring)) = d06e56a
Provides:       bundled(golang(github.com/mitchellh/copystructure)) = 1.0.0
Provides:       bundled(golang(github.com/mitchellh/go-homedir)) = 1.1.0
Provides:       bundled(golang(github.com/mitchellh/go-linereader)) = 1b945b3
Provides:       bundled(golang(github.com/mitchellh/go-testing-interface)) = 1.14.1
Provides:       bundled(golang(github.com/mitchellh/go-wordwrap)) = 1.0.0
Provides:       bundled(golang(github.com/mitchellh/hashstructure)) = 1.0.0
Provides:       bundled(golang(github.com/mitchellh/mapstructure)) = 1.4.1
Provides:       bundled(golang(github.com/mitchellh/panicwrap)) = 1.0.0
Provides:       bundled(golang(github.com/mitchellh/reflectwalk)) = 1.0.1
Provides:       bundled(golang(github.com/modern-go/concurrent)) = bacd9c7
Provides:       bundled(golang(github.com/modern-go/reflect2)) = 1.0.2
Provides:       bundled(golang(github.com/nicksnyder/go-i18n)) = 1.10.0
Provides:       bundled(golang(github.com/nu7hatch/gouuid)) = 179d4d0
Provides:       bundled(golang(github.com/oklog/run)) = 1.1.0
Provides:       bundled(golang(github.com/oklog/ulid)) = 1.3.1
Provides:       bundled(golang(github.com/opencontainers/go-digest)) = 1.0.0
Provides:       bundled(golang(github.com/opencontainers/image-spec)) = 775207b
Provides:       bundled(golang(github.com/openshift-metal3/terraform-provider-ironic)) = 0.2.7
Provides:       bundled(golang(github.com/openshift/api)) = d747270
Provides:       bundled(golang(github.com/openshift/client-go)) = 7385dd6
Provides:       bundled(golang(github.com/openshift/cloud-credential-operator)) = d10080b
Provides:       bundled(golang(github.com/openshift/cluster-api)) = f8de78a
Provides:       bundled(golang(github.com/openshift/cluster-api-provider-baremetal)) = c2d3ece
Provides:       bundled(golang(github.com/openshift/cluster-api-provider-ibmcloud)) = 4d7907a
Provides:       bundled(golang(github.com/openshift/cluster-api-provider-libvirt)) = 2336783
Provides:       bundled(golang(github.com/openshift/cluster-api-provider-ovirt)) = 06177b7
Provides:       bundled(golang(github.com/openshift/library-go)) = 5e31383
Provides:       bundled(golang(github.com/openshift/machine-config-operator)) = 4fe8559
Provides:       bundled(golang(github.com/ovirt/go-ovirt)) = ac0bcbc
Provides:       bundled(golang(github.com/ovirt/terraform-provider-ovirt)) = db1ac55
Provides:       bundled(golang(github.com/packer-community/winrmcp)) = c76d91c
Provides:       bundled(golang(github.com/pborman/uuid)) = 1.2.0
Provides:       bundled(golang(github.com/pelletier/go-toml)) = 1.9.3
Provides:       bundled(golang(github.com/pierrec/lz4)) = 2.6.1+incompatible
Provides:       bundled(golang(github.com/pkg/browser)) = 0a3d74b
Provides:       bundled(golang(github.com/pkg/errors)) = 0.9.1
Provides:       bundled(golang(github.com/pkg/sftp)) = 1.10.1
Provides:       bundled(golang(github.com/pmezard/go-difflib)) = 1.0.0
Provides:       bundled(golang(github.com/posener/complete)) = 1.2.3
Provides:       bundled(golang(github.com/pquerna/otp)) = 468c2dd
Provides:       bundled(golang(github.com/prometheus/client_golang)) = 1.11.0
Provides:       bundled(golang(github.com/prometheus/client_model)) = 0.2.0
Provides:       bundled(golang(github.com/prometheus/common)) = 0.28.0
Provides:       bundled(golang(github.com/prometheus/procfs)) = 0.6.0
Provides:       bundled(golang(github.com/rcrowley/go-metrics)) = 10cdbea
Provides:       bundled(golang(github.com/rickb777/date)) = 6300e54
Provides:       bundled(golang(github.com/rickb777/plural)) = 1.2.0
Provides:       bundled(golang(github.com/satori/go.uuid)) = 1.2.0
Provides:       bundled(golang(github.com/satori/uuid)) = 1.2.0
Provides:       bundled(golang(github.com/shopspring/decimal)) = 1.2.0
Provides:       bundled(golang(github.com/shurcooL/httpfs)) = 8d4bc4b
Provides:       bundled(golang(github.com/shurcooL/vfsgen)) = 6a9ea43
Provides:       bundled(golang(github.com/sirupsen/logrus)) = 1.8.1
Provides:       bundled(golang(github.com/softlayer/softlayer-go)) = 1.0.3
Provides:       bundled(golang(github.com/softlayer/xmlrpc)) = 5f089df
Provides:       bundled(golang(github.com/spf13/afero)) = 1.2.2
Provides:       bundled(golang(github.com/spf13/cobra)) = 1.2.1
Provides:       bundled(golang(github.com/spf13/pflag)) = 1.0.5
Provides:       bundled(golang(github.com/stoewer/go-strcase)) = 1.2.0
Provides:       bundled(golang(github.com/stretchr/testify)) = 1.7.0
Provides:       bundled(golang(github.com/svanharmelen/jsonapi)) = 0c0828c
Provides:       bundled(golang(github.com/terraform-provider-openstack/terraform-provider-openstack)) = 1.37.0
Provides:       bundled(golang(github.com/openshift/terraform-provider-aws)) = 24df6d7
Provides:       bundled(golang(github.com/openshift/terraform-provider-azurerm)) = 7509319
Provides:       bundled(golang(github.com/openshift/terraform-provider-azurestack)) = 0.10.0
Provides:       bundled(golang(github.com/community-terraform-providers/terraform-provider-ignition/v2)) = 2.1.0
Provides:       bundled(golang(github.com/terraform-providers/terraform-provider-local)) = 1.4.0
Provides:       bundled(golang(github.com/terraform-providers/terraform-provider-random)) = 83518d9
Provides:       bundled(golang(github.com/tjfoc/gmsm)) = 1.3.2
Provides:       bundled(golang(github.com/tombuildsstuff/giovanni)) = 0.15.1
Provides:       bundled(golang(github.com/ulikunitz/xz)) = 0.5.7
Provides:       bundled(golang(github.com/valyala/bytebufferpool)) = 1.0.0
Provides:       bundled(golang(github.com/valyala/fasthttp)) = 1.22.0
Provides:       bundled(golang(github.com/vincent-petithory/dataurl)) = d1553a7
Provides:       bundled(golang(github.com/vmihailenco/msgpack/v4)) = 4.3.12
Provides:       bundled(golang(github.com/vmihailenco/tagparser)) = 0.1.1
Provides:       bundled(golang(github.com/vmware/govmomi)) = 0.24.0
Provides:       bundled(golang(github.com/xanzy/ssh-agent)) = 0.2.1
Provides:       bundled(golang(github.com/xlab/treeprint)) = a009c39
Provides:       bundled(golang(github.com/zclconf/go-cty)) = 1.8.1
Provides:       bundled(golang(github.com/zclconf/go-cty-yaml)) = 1.0.2
Provides:       bundled(golang(go.mongodb.org/mongo-driver)) = 1.5.1
Provides:       bundled(golang(go.opencensus.io)) = 0.22.5
Provides:       bundled(golang(golang.org/x/crypto)) = 32db794
Provides:       bundled(golang(golang.org/x/lint)) = 6edffad
Provides:       bundled(golang(golang.org/x/mod)) = 0.4.2
Provides:       bundled(golang(golang.org/x/net)) = e898025
Provides:       bundled(golang(golang.org/x/oauth2)) = 2bc19b1
Provides:       bundled(golang(golang.org/x/sys)) = 6e78728
Provides:       bundled(golang(golang.org/x/term)) = 6886f2d
Provides:       bundled(golang(golang.org/x/text)) = 0.3.7
Provides:       bundled(golang(golang.org/x/time)) = 1f47c86
Provides:       bundled(golang(golang.org/x/tools)) = d4cc65f
Provides:       bundled(golang(golang.org/x/xerrors)) = 5ec99f8
Provides:       bundled(golang(gomodules.xyz/jsonpatch/v2)) = 2.2.0
Provides:       bundled(golang(google.golang.org/api)) = 0.33.0
Provides:       bundled(golang(google.golang.org/appengine)) = 1.6.7
Provides:       bundled(golang(google.golang.org/genproto)) = cb27e3a
Provides:       bundled(golang(google.golang.org/grpc)) = 1.35.0
Provides:       bundled(golang(google.golang.org/protobuf)) = 1.27.1
Provides:       bundled(golang(gopkg.in/go-playground/validator.v9)) = 9.31.0
Provides:       bundled(golang(gopkg.in/inf.v0)) = 0.9.1
Provides:       bundled(golang(gopkg.in/ini.v1)) = 1.66.2
Provides:       bundled(golang(gopkg.in/jcmturner/aescts.v1)) = 1.0.1
Provides:       bundled(golang(gopkg.in/jcmturner/dnsutils.v1)) = 1.0.1
Provides:       bundled(golang(gopkg.in/jcmturner/gokrb5.v7)) = 7.5.0
Provides:       bundled(golang(gopkg.in/jcmturner/rpc.v1)) = 1.1.0
Provides:       bundled(golang(gopkg.in/natefinch/lumberjack.v2)) = 2.0.0
Provides:       bundled(golang(gopkg.in/resty.v1)) = 1.12.0
Provides:       bundled(golang(gopkg.in/yaml.v2)) = 2.4.0
Provides:       bundled(golang(gopkg.in/yaml.v3)) = 496545a
Provides:       bundled(golang(honnef.co/go/tools)) = 0.0.1-2020.1.6
Provides:       bundled(golang(k8s.io/api)) = 0.23.0
Provides:       bundled(golang(k8s.io/apiextensions-apiserver)) = 0.23.0
Provides:       bundled(golang(k8s.io/apimachinery)) = 0.23.0
Provides:       bundled(golang(k8s.io/client-go)) = 0.23.0
Provides:       bundled(golang(k8s.io/component-base)) = 0.23.0
Provides:       bundled(golang(k8s.io/klog)) = 1.0.0
Provides:       bundled(golang(k8s.io/klog/v2)) = 2.30.0
Provides:       bundled(golang(k8s.io/kube-openapi)) = e816edb
Provides:       bundled(golang(k8s.io/utils)) = cb0fa31
Provides:       bundled(golang(github.com/openshift/cluster-api-provider-aws)) = 5ffc5f4
Provides:       bundled(golang(github.com/openshift/cluster-api-provider-openstack)) = 611d320
Provides:       bundled(golang(sigs.k8s.io/controller-runtime)) = 0.11.0
Provides:       bundled(golang(sigs.k8s.io/controller-tools)) = 6519034
Provides:       bundled(golang(sigs.k8s.io/json)) = c049b76
Provides:       bundled(golang(sigs.k8s.io/structured-merge-diff/v4)) = 4.2.0
Provides:       bundled(golang(sigs.k8s.io/yaml)) = 1.3.0
Provides:       bundled(golang(cloud.google.com/go)) = 0.57.0
Provides:       bundled(golang(github.com/openshift/terraform-provider-ibm)) = 1.26.2
Provides:       bundled(golang(github.com/go-log/log)) = a514cf0
Provides:       bundled(golang(github.com/gophercloud/gophercloud)) = 0.17.0
Provides:       bundled(golang(github.com/openshift/hashicorp-terraform)) = 0.14.6
Provides:       bundled(golang(github.com/openshift/hashicorp-terraform-plugin-sdk)) = 1.16.0
Provides:       bundled(golang(github.com/openshift/terraform-provider-vsphere)) = 1.24.3
Provides:       bundled(golang(github.com/openshift/baremetal-operator)) = 28771f4
Provides:       bundled(golang(github.com/openshift/baremetal-operator/apis)) = 28771f4
Provides:       bundled(golang(github.com/openshift/baremetal-operator/pkg/hardwareutils)) = 28771f4
Provides:       bundled(golang(github.com/openshift/client-go)) = 7385dd6
Provides:       bundled(golang(github.com/openshift/machine-config-operator)) = 4fe8559
Provides:       bundled(golang(github.com/spf13/afero)) = 1.2.2
Provides:       bundled(golang(github.com/openshift/terraform-provider-aws)) = 24df6d7
Provides:       bundled(golang(github.com/openshift/terraform-provider-azurerm)) = 7509319
Provides:       bundled(golang(github.com/openshift/terraform-provider-azurestack)) = 0.10.0
Provides:       bundled(golang(github.com/openshift/terraform-providers-terraform-provider-google)) = 7b79c6d
Provides:       bundled(golang(github.com/community-terraform-providers/terraform-provider-ignition/v2)) = 2.1.0
Provides:       bundled(golang(k8s.io/client-go)) = 0.23.0
Provides:       bundled(golang(k8s.io/kubectl)) = 0.23.0
Provides:       bundled(golang(github.com/openshift/cluster-api-provider-aws)) = 5ffc5f4
Provides:       bundled(golang(github.com/openshift/cluster-api-provider-azure)) = 5d94c79
Provides:       bundled(golang(github.com/openshift/cluster-api-provider-openstack)) = 611d320
Provides:       bundled(golang(sigs.k8s.io/controller-tools)) = 6519034
Provides:       bundled(golang(github.com/Azure/go-autorest/autorest)) = 0.11.17
Provides:       bundled(golang(github.com/Azure/go-autorest/autorest/adal)) = 0.9.10
Provides:       bundled(golang(github.com/Azure/go-autorest/autorest/date)) = 0.3.0
Provides:       bundled(golang(github.com/Azure/go-autorest/autorest/validation)) = 0.3.1
Provides:       bundled(golang(github.com/IBM/vpc-go-sdk)) = 0.7.0
Provides:       bundled(golang(github.com/apparentlymart/go-cidr)) = 1.1.0
Provides:       bundled(golang(github.com/aws/aws-sdk-go)) = 1.35.37
Provides:       bundled(golang(github.com/go-openapi/errors)) = 0.19.2
Provides:       bundled(golang(github.com/go-openapi/spec)) = 0.19.4
Provides:       bundled(golang(github.com/go-openapi/validate)) = 0.19.8
Provides:       bundled(golang(github.com/hashicorp/go-getter)) = 1.5.2
Provides:       bundled(golang(github.com/hashicorp/go-plugin)) = 1.3.0
Provides:       bundled(golang(github.com/hashicorp/terraform-plugin-test/v2)) = 2.2.0
Provides:       bundled(golang(github.com/ulikunitz/xz)) = 0.5.7
Provides:       bundled(golang(google.golang.org/api)) = 0.33.0
Provides:       bundled(golang(google.golang.org/genproto)) = cb27e3a
Provides:       bundled(golang(google.golang.org/grpc)) = 1.35.0

%description
Install an OpenShift 4.x cluster.
Supported Platforms:
  - AWS
  - AWS (UPI)
  - Azure
  - Bare Metal (UPI)
  - Bare Metal (IPI)
  - GCP
  - GCP (UPI)
  - Libvirt with KVM (development only)
  - OpenStack
  - OpenStack (UPI)
  - Power
  - oVirt
  - oVirt (UPI)
  - vSphere
  - vSphere (UPI)
  - z/VM

%prep
%autosetup -n installer-%{commit}

%build
%if 0%{?major} == 4 && 0%{?minor} >= 11
# Build all terraform targets
%make_build -C terraform all

# Copy terraform parts to embedded mirror.
export TARGET_OS_ARCH=$(go env GOOS)_$(go env GOARCH)

find "%{_builddir}/%{repo}-%{commit}/terraform/bin/${TARGET_OS_ARCH}/" -maxdepth 1 -name "terraform-provider-*.zip" -exec bash -c '
      providerName="$(basename "$1" | cut -d '-' -f 3 | cut -d '.' -f 1)"
      targetOSArch="$2"
      dstDir="%{_builddir}/%{repo}-%{commit}/pkg/terraform/providers/mirror/openshift/local/$providerName"
      mkdir -p "$dstDir"
      echo "Copying $providerName provider to mirror"
      cp "$1" "$dstDir/terraform-provider-${providerName}_1.0.0_${targetOSArch}.zip"
    ' shell {} "${TARGET_OS_ARCH}" \;
mkdir -p %{_builddir}/%{repo}-%{commit}/pkg/terraform/providers/mirror/terraform/
cp "%{_builddir}/%{repo}-%{commit}/terraform/bin/${TARGET_OS_ARCH}/terraform" "%{_builddir}/%{repo}-%{commit}/pkg/terraform/providers/mirror/terraform/"
%endif

# Build openshift-installer
export LDFLAGS="-s -w -X %{goipath}/pkg/version.Raw=%{version} -X %{goipath}/pkg/version.Commit=%{commit} -X %{goipath}/pkg/version.defaultArch=%{defaultArch}"
export GOFLAGS="${GOFLAGS:--mod=vendor}"
export BUILDTAGS="release"
export CGO_ENABLED=0
go mod vendor
go generate ./data
go build "${GOFLAGS}" -ldflags "${LDFLAGS}" -tags "${BUILDTAGS}" -o ./bin/openshift-install %{goipath}/cmd/openshift-install

%install
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp ./bin/*             %{buildroot}%{_bindir}/

# Install bash completions
install -d -m 0755 %{buildroot}%{_sysconfdir}/bash_completion.d/
echo "+++ INSTALLING BASH COMPLETIONS FOR openshift-install "
%{buildroot}%{_bindir}/openshift-install completion bash > %{buildroot}%{_sysconfdir}/bash_completion.d/openshift-install
chmod 644 %{buildroot}%{_sysconfdir}/bash_completion.d/openshift-install

%if %{with check}
%check
%gocheck
%endif

%files
%license LICENSE NOTICE
%doc docs CHANGELOG.md CONTRIBUTING.md README.md code-of-conduct.md
%doc data/data/baremetal/bootstrap/README.md
%doc data/data/bootstrap/baremetal/README.md
%if 0%{?major} == 4 && 0%{?minor} >= 11
%doc data/data/bootstrap/nutanix/README.md
%doc pkg/terraform/providers/mirror/README
%endif
%doc data/data/bootstrap/ovirt/README.md
%doc data/data/libvirt/bootstrap/README.md images/libvirt/README.md
%doc upi/openstack/README.md
%doc upi/ovirt/README.md upi/vsphere/README.md upi/metal/README.md
%{_bindir}/openshift-install
%{_sysconfdir}/bash_completion.d/openshift-install

%changelog
* Tue Oct 04 2022 Luca Magrone <luca@magrone.cc> - 4.10.0-1%{?dist}
- Initial package
